#!/usr/bin/env python
# -*- cofing: utf-8 -*-
# vim:noet:sw=4:ts=4:ft=vim

import os
import pycurl
import urllib2
import urllib
import re
# For the goo.gl shortening
from math import floor
# For parsing the XML responses
from lxml import etree

URONE_MATCH = "Your ur1 is: <a href=\"([^\"]+)\">"

def short_bitly(username, apikey, longurl):
    """docstring for short_bitly"""
    try:
        login = urllib.urlencode(dict(login=username))
        apikey = urllib.urlencode(dict(apiKey=apikey))
        longurl = urllib.urlencode(dict(longUrl=longurl))
        request = urllib.urlopen("http://api.bit.ly/v3/shorten?%s&%s&%s&format=txt" % (login, apikey, longurl))
        response = request.read()
        if "RATE_LIMIT" in response:
            return "ratelimit"
        else:
            return response.strip("\n")
    except:
        return 0

def short_isgd(longurl):
    """docstring for short_isgd"""
    try:
        longurl = urllib.urlencode(dict(longurl=longurl))
        request = urllib.urlopen("http://is.gd/api.php?%s" % longurl)
        response = request.read()
        request.close()
        return response
    except:
        return 0

def short_googl(longurl):
    """docstring for short_googl"""
    google_token = GoogleToken()
    auth_token = google_token.g(longurl)
    params = "user=toobar@google.com&url="+urllib.quote_plus(longurl, "!'*()~_.-")+"&auth_token"+auth_token

    request = urllib2.Request(url='http://goo.gl/api/url', data=params)
    request.add_header('Content-Type', 'application/x-www-form-urlencoded')
    request.add_header('User-Agent', 'Mozilla/5.0')
    response = urllib2.urlopen(request)
    response_data = response.read()

    data = eval(response_data.decode('utf-8'))
    if data.has_key('short_url'):
        result = data['short_url']
    elif data.has_key('error_message'):
        result = "Error: %s" % data['error_message']

    return result

def short_cligs(apikey, longurl):
    """docstring for short_cligs"""
    #http://cli.gs/api/v1/cligs/create?url=1&title=2&key=3&appid=4
    longUrl = urllib.urlencode(dict(url=longurl))
    appId = 'pyBit'
    request = urllib.urlopen('http://cli.gs/api/v1/cligs/create?%s&key=%s&appid=%s' % (longUrl, apikey, appId))
    response = request.read()
    if "http://" in response:
            return response
    else:
            return 0 

def short_smshme(longurl):
    #http://smsh.me/?api=API_format&url=http%3A%2F%2Fyour.url%2Fto%20sm00sh
    """docstring for short_smshme"""
    longUrl = urllib.urlencode(dict(longurl=longurl))
    request = urllib.urlopen('http://smsh.me/?api=json&url=%s' % longUrl)
    response = request.read()
    request.close()
    respond_dict = eval(response)
    if respond_dict['body']:
        return respond_dict['body']
    else:
        return 0

def short_snipurl(username, apikey, longurl):
    """docstring for short_snipurl"""
    params = urllib.urlencode({'sniplink': longurl, 'snipuser': username, 'snipapi': apikey, 'snipformat': 'simple'})
    request = urllib.urlopen('http://sn.im/site/getsnip', params)
    response = request.read()
    if "http://" in response:
            return response
    else:
            return 0


def short_pingfm(userapi, longurl):
    """docstring for short_pingfm"""
    apikey = "22baff19874a7c620dc3501aec6e8aa1"
    try:
        params = urllib.urlencode({'api_key': apikey, 'user_app_key': userapi, 'long_url': longurl})
        request = urllib.urlopen('http://api.ping.fm/v1/url.create', params)
        response = etree.XML(request.read())
        url = response.findtext("short_url")
        return url
    except:
        return 0

def short_ur1(longurl):
    """docstring for short_ur1"""
    try:
        params = urllib.urlencode({'longurl': longurl, 'submit': 'Make it an ur1!'})
        request = urllib.urlopen('http://ur1.ca', params)
        response = request.read()
        if re.findall(URONE_MATCH, response)[0]:
            url = re.findall(URONE_MATCH, response)[0]
            return url
        else:
            return 0
    except:
            return 0

def short_ur1bz(longurl):
        """docstring for short_ur1bz"""
        try:
                params = urllib.urlencode(dict(url=longurl))
                request = urllib.urlopen('http://ur1.bz/api.php?%s' % params)
                response = request.read()
                if "http://" in response:
                        return response
                else:
                        return "Invalid URL supplied!"
        except:
                return "ERROR"


class GoogleToken():
    def __c(self, *args):
        l = 0
        for p in args:
            l = l + p & 4294967295
        return l

    def __d(self, l):
        m = "%d" % (l if l > 0 else l + 4294967296)
        o = 0
        n = False
        for p in range(len(m)-1, -1, -1):
            q = int(m[p])
            if n:
                q *= 2
                o += floor(q / 10) + q % 10
            else:
                o += q
            n = not n
        m = m = o % 10
        o = 0
        if (m != 0):
            o = 10 - m
            if (len("%d" % l) % 2 == 1):
                if (o % 2 == 1):
                    o += 9
                o /= 2
        m = "%d" % o
        m += ("%d" % l)
        l = m
        return l

    def __e(self, l):
        m = 5381
        for o in range(len(l)):
            m = self.__c(m << 5, m, ord(l[o]))
        return m

    def __f(self, l):
        m = 0
        for o in range(len(l)):
            m = self.__c(ord(l[o]), m << 6, m << 16, -m)
        return m

    def g(self, b):
        i = self.__e(b)
        i = i >> 2 & 1073741823
        i = i >> 4 & 67108800 | i & 63
        i = i >> 4 & 4193280 | i & 1023
        i = i >> 4 & 245760 | i & 16383
        h = self.__f(b)
        k = (i >> 2 & 15) << 4 | h & 15
        k |= (i >> 6 & 15) << 12 | (h >> 8 & 15) << 8
        k |= (i >> 10 & 15) << 20 | (h >> 16 & 15) << 16
        k |= (i >> 14 & 15) << 28 | (h >> 24 & 15) << 24
        j = "7" + self.__d(k)
        return j
